//---------------------------------------------------------------------------

#ifndef UnitControlSkypeH
#define UnitControlSkypeH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <IdSMTP.hpp>
#include <Graphics.hpp>

#include "SQLiteTable3.hpp"
#define WM_TRAYNOTIFY (WM_USER + 1007)

typedef AnsiString AStr;

class TMessageSkype
 {
   public:
   int Asked;
   int Id;
   int TS; // timestamp
   AStr UserName;
   AStr Question;
   AStr Ask;
   AStr Path;
   AStr FneQuestion;
   TMessageSkype() {};
   ~TMessageSkype() {};
 };

//---------------------------------------------------------------------------
class TFormControlSkype : public TForm
{
__published:	// IDE-managed Components
	TPanel *PanelTop;
	TPanel *PanelMain;
	TPageControl *PageControl;
	TTabSheet *TabSheetMessages;
	TTabSheet *TabSheetSetting;
	TTabSheet *TabSheetAbout;
	TMemo *MemoInform;
	TTimer *Timer;
	TButton *ButtonEmailSend;
	TLabel *Label4;
	TEdit *EditEmailRecieve;
	TEdit *EditEmailPassword;
	TLabel *Label3;
	TLabel *Label2;
	TEdit *EditEmail;
	TLabel *Label1;
	TEdit *EditEmailText;
	TLabel *Label7;
	TLabel *Label5;
	TEdit *EditEmailSubject;
	TImage *ImageTrayStop;
	TLabel *Label6;
	TEdit *EditTimerInterval;
	TCheckBox *CheckBoxControl;
	TMemo *MemoAbout;
	TCheckBox *CheckBoxViewPassword;
	TLabel *Label8;
	TEdit *EditPathDB;
	TButton *ButtonLastMessage;
	TButton *ButtonExit;
	TTimer *TimerScan;
	TTabSheet *TabSheetMan;
	TTabSheet *TabSheetAdd;
	TCheckBox *CheckBoxKeyInterval;
	TLabel *Label10;
	TEdit *EditTimerScan;
	TLabel *Label9;
	TEdit *EditPathMan;
	TEdit *EditPathDBMan;
	TLabel *Label11;
	TButton *ButtonDefWindowsSkype;
	TCheckBox *CheckBoxMan;
	TGroupBox *GroupBox1;
	TEdit *EditTime1;
	TLabel *Label12;
	TLabel *Label13;
	TEdit *EditTime2;
	TButton *ButtonAllToFile;
	TTimer *TimerAutoNotification;
	TCheckBox *CheckBoxAutoNotification;
	void __fastcall Label1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall TimerTimer(TObject *Sender);
	void __fastcall ButtonEmailSendClick(TObject *Sender);
	void __fastcall CheckBoxControlClick(TObject *Sender);
	void __fastcall Label1MouseLeave(TObject *Sender);
	void __fastcall Label1MouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall CheckBoxViewPasswordClick(TObject *Sender);
	void __fastcall ButtonLastMessageClick(TObject *Sender);
	void __fastcall ButtonDefWindowsSkypeClick(TObject *Sender);
	void __fastcall ButtonExitClick(TObject *Sender);
	void __fastcall TimerScanTimer(TObject *Sender);
	void __fastcall EditPathDBExit(TObject *Sender);
	void __fastcall ButtonAllToFileClick(TObject *Sender);
	void __fastcall CheckBoxAutoNotificationClick(TObject *Sender);
	void __fastcall TimerAutoNotificationTimer(TObject *Sender);


private: // User declarations
    TList*           ListMS;
	char             p[256];
	int              CanCloseProgram;
	int              SkipInformTimer;
	int              TrayIconID;
	AStr             CaptionThisProgram;
	AStr             MainClassSkype;
	AStr             LastCaptionSkype;
	AStr             PfneIni;
	TDateTime        DTLastInform;
	TPopupMenu*      PopupMenuTrayIcon;
	Graphics::TIcon* TrayIcon;
	int MouseX;
	int MouseY;
	int MouseC;
	int  __fastcall AlreadyRunning(void);
	int  __fastcall StrToStrsWS(const AStr S, const AStr Delim, TStrings *Ss);
	AStr __fastcall FormBoundsToStr(TForm *Form);
	void __fastcall StrToFormBounds(AStr S, TForm *Form);
	int  __fastcall FindAllDirs(const AStr Path, TStrings *Dirs);
	AStr __fastcall GetStrReplace(const AStr Value, const AStr S1, const AStr S2);
	AStr __fastcall DTToStr(const System::TDateTime Value);
	AStr __fastcall ExtractPathFromPfne(const AStr Pfne);
	void __fastcall Inform(AStr Value);
	void __fastcall TimerSwitch(void);
	void __fastcall ControlSkype(void);
	void __fastcall TrayIconAdd(TImage* Image, AStr Hint);
	void __fastcall TrayIconRemove(void);
	void __fastcall TrayIconNotify(TMessage &Msg);
	void __fastcall PopupMenuTrayIconAddItem(int Tag, int Checked, AStr dCaption);
	int  __fastcall DefineLastMessageSkype(void);
	int  __fastcall AllMessagesToFile(void);
	AStr __fastcall CP1251ToAnsi(System::UnicodeString U);
	AStr __fastcall RusToLatin(AStr V);
	TList* __fastcall ReturnListHWNDWindowByCaptionAndClass(const AStr CaptionWindow,const AStr ClassWindow, HWND hParent);
	HWND   __fastcall DefineChatSkype(AStr CaptionWindow);
	TMessageSkype* __fastcall DefineMessageSkype(int id);
	int    __fastcall SendMessageInChatSkype(AStr CaptionWindow, TStrings* Ss);
	int    __fastcall CreateQuestion(TMessageSkype* MessageSkype);
	AStr   __fastcall StrToNumUTF8(AStr Value);
	AStr   __fastcall TSToDate(int ts);
	AStr   __fastcall TSToTime(int ts);
	void   __fastcall Keystroke(void);
	TStringList* SLTemp;
	TSQLiteDatabase* DBSkype;
	int Created;
public:		// User declarations

	__fastcall TFormControlSkype(TComponent* Owner);
	void __fastcall PopupMenuTrayIconClick(TObject* Sender);

BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_TRAYNOTIFY,TMessage,TrayIconNotify)
END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TFormControlSkype *FormControlSkype;
//---------------------------------------------------------------------------
#endif
